/*
 ==============================================================================================================================================
 Author      : CHEONG SE HANG (dit.dhc@lostcity-studio.com)
 Description : The implementation of Queue.
 ==============================================================================================================================================
 */
#include "Queue4SendData.h"
#include "Log.h"
#include <stdlib.h>
#include <stdio.h>
/*---------------------------------------------------------------------------------------------------------------------------------------------
 *
 *                                                              Public Functions
 *
 *-------------------------------------------------------------------------------------------------------------------------------------------*/
void Queue4SendData_Clear ( struct Queue4SendData *Q ) {
    if ( Q == NULL )
        return;
    Q->count = Q->front = Q->rear = 0;
//    while ( Queue4IONodeStruct_GetCount ( Q ) )
//        free( Queue4IONodeStruct_Pop( Q ) );
}


void Queue4SendData_Destroy ( struct Queue4SendData *Q ) {
    Queue4SendData_Clear( Q );
//    free( Q->qlist );
//    free( Q );
}


struct SendDataStruct Queue4SendData_Get ( struct Queue4SendData *Q ) {
    if ( Q == NULL || Q->count == 0 ) {
        char buf[ 128 ];
        sprintf( buf, "[QUEUE] EMPTY!" );
        Log( buf );
        exit( -1 );
//        return NULL;
    }
    return Q->qlist[ Q->front ];
}


int Queue4SendData_GetCount ( struct Queue4SendData *Q ) {
    if ( Q == NULL )
        return -1;
    return Q->count;
}


void Queue4SendData_Init ( struct Queue4SendData *q, int size ) {
//    struct Queue4IONodeStruct *q;
//    if ( ( q = malloc( sizeof ( struct Queue4IONodeStruct ) ) ) == NULL )
//        return NULL;
//    if ( ( q->qlist = malloc( sizeof( struct IONodeStruct ) * size ) ) == NULL ) {
//        char buf[ 128 ];
//        sprintf( buf, "[QUEUE] NO MEMORY!" );
//        Log( buf );
//        exit( -1 );
//    }
    q->count = q->front = q->rear = 0;
    q->size = size;
//    return q;
}


int Queue4SendData_Insert ( struct Queue4SendData *Q, struct SendDataStruct addr ) {
    if ( Q == NULL || Q->count == Q->size ) {
        return -1;
    }
    Q->count++;
    Q->qlist[ Q->rear ] = addr;
    Q->rear = ( Q->rear + 1 ) % Q->size;
    return 0;
}


struct SendDataStruct Queue4SendData_Pop ( struct Queue4SendData *Q ) {
    struct SendDataStruct ret;
    if ( Q == NULL || Q->count == 0 ) {
        char buf[ 128 ];
        sprintf( buf, "[QUEUE] EMPTY!" );
        Log( buf );
        exit( -1 );
//        return NULL;
    }
    ret = Q->qlist[ Q->front ];
    Q->count--;
    Q->front = ( Q->front + 1 ) % Q->size;
    return ret;
}
