/*
 ==============================================================================================================================================
 Author      : CHEONG SE HANG (dit.dhc@lostcity-studio.com)
 Description : Fundamental data type.
 ==============================================================================================================================================
 */
#ifndef TYPE_H_
#define TYPE_H_
/*---------------------------------------------------------------------------------------------------------------------------------------------
 *
 *                                                              Structure Definitions
 *
 *-------------------------------------------------------------------------------------------------------------------------------------------*/
typedef char                INT8;       /* 8-bit signed integer. */
typedef unsigned char       UINT8;      /* 8-bit unsigned integer. */
typedef unsigned char       UCHAR;      /* 8-bit unsigned integer. */
typedef unsigned char       BYTE;       /* 8-bit unsigned integer. */
typedef short int           INT16;      /* 16-bit signed integer. */
typedef unsigned short int  UINT16;     /* 16-bit unsigned integer. */
typedef unsigned short int  WORD;       /* 16-bit unsigned integer. */
typedef int                 INT32;      /* 32-bit signed integer. */
typedef unsigned int        UINT32;     /* 32-bit unsigned integer. */
typedef unsigned int        LONG;       /* 32-bit unsigned integer. */
typedef unsigned int        DWORD;      /* 32-bit unsigned integer. */
typedef float               FLOAT;      /* IEEE floating point. */
typedef enum { FALSE = 0, TRUE } BOOL;  /* Boolean. */
typedef enum { OFF = 0, ON } SWITCH;    /* Switch. */


typedef struct {        /* BITARRAY8 - 8 bits. */
    unsigned b0 : 1;
    unsigned b1 : 1;
    unsigned b2 : 1;
    unsigned b3 : 1;
    unsigned b4 : 1;
    unsigned b5 : 1;
    unsigned b6 : 1;
    unsigned b7 : 1;
} BITARRAY8;


typedef struct {        /* BITARRAY8 - 16 bits. */
    unsigned b0  : 1;
    unsigned b1  : 1;
    unsigned b2  : 1;
    unsigned b3  : 1;
    unsigned b4  : 1;
    unsigned b5  : 1;
    unsigned b6  : 1;
    unsigned b7  : 1;
    unsigned b8  : 1;
    unsigned b9  : 1;
    unsigned b10 : 1;
    unsigned b11 : 1;
    unsigned b12 : 1;
    unsigned b13 : 1;
    unsigned b14 : 1;
    unsigned b15 : 1;
} BITARRAY16;


typedef struct {        /* BITARRAY8 - 32 bits. */
    unsigned b0  : 1;
    unsigned b1  : 1;
    unsigned b2  : 1;
    unsigned b3  : 1;
    unsigned b4  : 1;
    unsigned b5  : 1;
    unsigned b6  : 1;
    unsigned b7  : 1;
    unsigned b8  : 1;
    unsigned b9  : 1;
    unsigned b10 : 1;
    unsigned b11 : 1;
    unsigned b12 : 1;
    unsigned b13 : 1;
    unsigned b14 : 1;
    unsigned b15 : 1;
    unsigned b16 : 1;
    unsigned b17 : 1;
    unsigned b18 : 1;
    unsigned b19 : 1;
    unsigned b20 : 1;
    unsigned b21 : 1;
    unsigned b22 : 1;
    unsigned b23 : 1;
    unsigned b24 : 1;
    unsigned b25 : 1;
    unsigned b26 : 1;
    unsigned b27 : 1;
    unsigned b28 : 1;
    unsigned b29 : 1;
    unsigned b30 : 1;
    unsigned b31 : 1;
} BITARRAY32;


typedef union {         /* Byte base - 16 bits. */
    UINT8  uc[ 2 ];
    INT8   sc[ 2 ];
    UINT16 ui;
    INT16  si;
    UINT8  u8[ 2 ];
    INT8   s8[ 2 ];
    UINT16 u16;
    INT16  s16;
    BITARRAY16 ba;
} BYTEBASE16;


typedef union {         /* Byte base - 32 bits. */
    UINT8  u8[ 4 ];
    INT8   s8[ 4 ];
    UINT16 u16[ 2 ];
    INT16  s16[ 2 ];
    UINT32 u32;
    INT32  s32;
    FLOAT  f32;
    UINT8  uc[ 4 ];
    INT8   sc[ 4 ];
    UINT16 ui[ 2 ];
    INT16  si[ 2 ];
    UINT32 ul;
    INT32  sl;
    FLOAT  f;
    BITARRAY32 ba;
} BYTEBASE32;




#endif /* TYPE_H_ */
